import { modalStore } from './store';
// modal 事件实现
const ModalEvent = {
  //
};
const onClick = (e: MouseEvent) => {
  const target = e.target as HTMLElement;
  if (!target) {
    console.log('target is null');
    return;
  }
  if (target.classList.contains('ui-modal-mask')) {
    const modalState = modalStore.getState();
    const modal = modalState.modals.find((modal) => modal.id === target.dataset.id);
    if (modal && modal.open) {
      modal.onMaskClose(e);
    }
    e.preventDefault();
    return;
  }
  // const parentModalRoot = target.closest('.ui-modal-root');
  // if (!parentModalRoot) {
  //   return;
  // }
};

export const InitModalEvent = (el: HTMLDivElement) => {
  const id = el.id;
  if (ModalEvent[id] && el === ModalEvent[id]) {
    return;
  }
  // Remove previous event listener to prevent memory leak
  if (ModalEvent[id]) {
    ModalEvent[id].removeEventListener('click', onClick);
  }
  ModalEvent[id] = null;
  el.addEventListener('click', onClick);
  ModalEvent[id] = el;
};
